# Tham khao: https://realpython.com/linear-programming-python/
import pulp as p

# Dem so luong rang buoc
while True:
    numOfConstraints = int(input("Nhap so rang buoc (2 den 10): "))
    if numOfConstraints >= 2 and numOfConstraints <= 10:
        break

constraint = []  # He so rang buoc
c = []  # He so ham muc tieu

# Nhap he so rang buoc
print("Nhap cac he so cua rang buoc (-50 den 50): ")
for i in range(numOfConstraints):
    a = []
    for j in range(3):
        while True:
            print("[", i, "][", j, "]: ", end="")
            num = int(input())
            if num <= 50 and num >= -50:
                a.append(num)
                break
    constraint.append(a)

# Tao model
model1 = p.LpProblem(name="model1", sense=p.LpMaximize)
model2 = p.LpProblem(name="model2", sense=p.LpMinimize)
x1 = p.LpVariable(name="x1", lowBound=0, cat="Continuous")
x2 = p.LpVariable(name="x2", lowBound=0, cat="Continuous")

for i in range(numOfConstraints):
    model1 += p.lpSum([constraint[i][0] * x1,
                       constraint[i][1] * x2]) <= constraint[i][2]
    model2 += p.lpSum([constraint[i][0] * x1, constraint[i]
                       [1] * x2]) <= constraint[i][2]


# Nhap he so ham muc tieu
print("Nhap he so ham muc tieu (-50 den 50): ")
for i in range(2):
    while True:
        print("c[", i, "]: ", end="")
        num = int(input())
        if num <= 50 and num >= -50:
            c.append(num)
            break

model1 += p.lpSum([c[0] * x1, c[1] * x2])
model2 += p.lpSum([c[0] * x1, c[1] * x2])

# Giai va in ket qua
statusMax = model1.solve()
if statusMax == 1:
    print("Trang thai (Lon nhat): Toi uu")
else:
    print("Trang thai (Lon nhat): Khong toi uu")

maxValue = p.value(model1.objective)
print("Gia tri lon nhat cua ham muc tieu: ", maxValue)
for v in model1.variables():
    print(v.name, "=", v.varValue)
print(end="\n")

statusMin = model2.solve()
if statusMin == 1:
    print("Trang thai (Lon nhat): Toi uu")
else:
    print("Trang thai (Lon nhat): Khong toi uu")
minValue = p.value(model2.objective)
print("Gia tri nho nhat cua ham muc tieu: ", minValue)
for v in model2.variables():
    print(v.name, "=", v.varValue)

print(end="\n")